/* Soot - a J*va Optimization Framework
 * Copyright (C) 2010 Eric Bodden
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

package summary;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collection;
import soot.Scene;
import soot.SootMethod;

public class AppCallLog {
	
	private Collection<SootMethod> methods;

	public AppCallLog(String logFile) {
		methods = new ArrayList<SootMethod>();
		try {
			BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(logFile)));
			String line;
			while ((line = reader.readLine()) != null) {
				if (line.length() == 0)
					continue;
				String methodSignature = line;
				SootMethod method = Scene.v().getMethod(methodSignature);
				methods.add(method);
			}
			reader.close();
		} catch (FileNotFoundException e) {
			throw new RuntimeException("Log file "+ logFile + " not found.", e);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
	
	public Collection<SootMethod> getMethods() {
		return methods;
	}
}